package w6.ex1.deadlock.sol;

public class Person extends Thread {
	private String name;
	private Person whomToAsk;

	public Person(String name) {
		this.name = name;
	}

	public void setWhomToAsk(Person whomToAsk) {
		this.whomToAsk = whomToAsk;
	}

	public String toString() {
		return name;
	}

	private void getAQuestionFrom(Person p) {
		// Only synchronize during thinking...
		synchronized (this) {
			try {
				System.out.println(this + " says: I got a question from " + p);
				// Think a while before answering...
				Thread.sleep((int) (Math.random() * 1000) + 1000);
			} catch (InterruptedException e) {
				Thread.currentThread().interrupt();
			}
		}
		// ... release the synchronization when done thinking.
		p.getAnAnswerFrom(this);
	}

	private synchronized void getAnAnswerFrom(Person p) {
		System.out.println(this + " says: I got an answer from " + p);
	}

	public void run() {
		whomToAsk.getAQuestionFrom(this);
	}

	public static void main(String[] args) {
		Person p1 = new Person("Pelle");
		Person p2 = new Person("Emil");
		p1.setWhomToAsk(p2);
		p2.setWhomToAsk(p1);
		p1.start();
		p2.start();
	}
}