package w6.ex1.invar.ex;

/**
 * @invariant r + g + b > THRESHOLD
 * @invariant Think of one more reasonable invariant...
 */
public class LightColor {
	public static final int THRESHOLD = 384;
	private int r, g, b;
	
	/**
	 * @throws IllegalArgumentException if the colour specified by r, g, b is too dark.
	 */
	public LightColor(int r, int g, int b) {
		setColor(r, g, b);
	}
	
	/**
	 * @pre What should the precondition(s) be?
	 * @post What should the postcondition(s) be?
	 * @throws IllegalArgumentException if the colour specified by r, g, b is too dark.
	 */
	public void setColor(int r, int g, int b) {
		if(checkInvariant(r, g, b)) {
			this.r = r;
			this.g = g;
			this.b = b;
		} else {
			throw new IllegalArgumentException(
					"The sum of r, g, b must be greater than " + THRESHOLD);
		}
	}
	
	// See setColor(int, int, int)
	public void setColor(Color c) {
		setColor(c.getRed(), c.getGreen(), c.getBlue());
	}
	
	/**
	 * Returns a Color-view of this object.
	 * @pre What should the precondition(s) be?
     * @throws Can this method throw?
	 */
	public Color asColor() {
		return new Color(r, g, b);
	}
	
	// Make sure that the the rgb triple will satisfy the invariant. 
	private boolean checkInvariant(int r, int g, int b) {
		return r + g + b > THRESHOLD;
	}
}
