package w6.ex2.innerclass.ex;

import java.util.Map;
import java.util.HashMap;

public class GameKeeper {
	private static Map<String, Game> games = new HashMap<String, Game>();

	public static void registerGame(String name, GameModel model,
					GameView view) {
		games.put(name, new Game(model, view));
	}

	public static GameView getGameView(String name) {
		return games.get(name).view;
	}

	public static GameModel getGameModel(String name) {
		return games.get(name).model;
	}

	private static class Game {
		public final GameModel model;
		public final GameView view;

		public Game(GameModel model, GameView view) {
			if (model == null || view == null) {
				throw new IllegalArgumentException(
						"model or view must not be null");
			}
			this.model = model;
			this.view = view;
		}

		public int hashCode() {
			return this.model.hashCode() * 876543 +
					this.view.hashCode() * 23456789;
		}

		public boolean equals(Object o) {
			if (o == null) {
				return false;
			} else if (o.getClass() != this.getClass()) {
				return false;
			}
			Game game = (Game) o;
			return game.model.equals(this.model) &&
					game.view.equals(this.view);
		}
	}

	// Provided so that this file can compile...
	private class GameModel {
	}

	// Provided so that this file can compile...
	private class GameView {
	}
}