package w6.ex3.integertransfer.sol;

import java.util.Scanner;
import java.util.List;
import java.util.ArrayList;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.DataOutputStream;

public class IntegerTransfer {
	private static final int ERROR_ARGS = 1;
	private static final int ERROR_FILES = 2;

	public static void readIntegersNew(List<Integer> storage)
			throws Exception {
		Scanner in = new Scanner(System.in);

		System.out.print("Input a list of integers: ");
		System.out.flush();

		try {
			while (in.hasNextInt()) {
				storage.add(in.nextInt());
			}

		} catch (IllegalStateException e) {
			throw new Exception(
					"Error, scanner closed during reading of input", e);
		}

	}

	public static void writeIntegers(List<Integer> storage,
										String binFilename,
										String textFilename) throws Exception {
		// Create binary and text file writers
		DataOutputStream binWriter = new DataOutputStream(
										new FileOutputStream(binFilename));
		PrintWriter textWriter = new PrintWriter(textFilename);

		try {
			// Iterate over collection and write contained numbers
			for (int num : storage) {
				binWriter.writeInt(num);
				textWriter.println(num);
			}
		} catch (IOException e) {
			throw new Exception("Error writing to binary file...", e);
		} finally {
			binWriter.close();
			textWriter.close();
		}
	}

	public static void main(String[] args) {
		// Check number of arguments
		if (args.length < 2) {
			System.out.println("Too few arguments"
					+ "\nUsage IntegerTransfer <binary output file> "
					+ "\n<text output file>");
			System.exit(ERROR_ARGS);
		}

		// Create storage
		List<Integer> numStorage = new ArrayList<Integer>();

		// Read and write numbers
		try {
			readIntegersNew(numStorage);
			writeIntegers(numStorage, args[0], args[1]);
		} catch (Exception e) {
			System.err.println(e.getCause().getMessage());
			System.exit(ERROR_FILES);
		}

	}
}
